/*
** SellaNMS
** $Id: daemon.cxx,v 1.17 2005/11/27 00:18:03 sella Exp $
** Copyright (c) 2001-2005 Digital Genesis Software, LLC. All Rights Reserved.
** Released under the GPL Version 2 License.
** http://www.digitalgenesis.com
*/

#include "daemon.h"
#include "syslog.h"
#include <signal.h>

static const char rcsid[] = "$Id: daemon.cxx,v 1.17 2005/11/27 00:18:03 sella Exp $";

void sighandler(int sig) {
	switch (sig) {
		case SIGUSR1:
			LMSG("Caught SIGUSR1 - daemon");
			break;

		case SIGUSR2:
			LMSG("Caught SIGUSR2 - daemon");
			break;

		default:
			LMSG("Caught unknown signal - daemon");
	}
}

bool start() {
	Syslog *syslog = NULL;

	/* Install Signal Handlers */
	if (signal(SIGUSR1, &sighandler) == SIG_ERR) {
		LMSG("Failed to install signal handler for SIGUSR1.");
	}
	if (signal(SIGUSR2, &sighandler) == SIG_ERR) {
		LMSG("Failed to install signal handler for SIGUSR2.");
	}

	if ((syslog = new Syslog()) != NULL) {
		if (syslog->readConfig() == SUCCESS) {
			syslog->execute();
		}

		SAFE_DELETE(syslog);
	} else {
		LMSG("failed to allocate memory for Syslog().");

		return false;
	}

	return true;
}

const char* getName() {
	return "mon.syslogd";
}

const char* getDefaultConfigPath() {
	return "monitor syslog";
}

const char* getProcTitle() {
	return getName();
}

const char* getDefaultConfigFile() {
	return DEFAULT_CONFIG_FILE;
}

const char* getDefaultPidFile() {
	return DEFAULT_PID_FILE;
}

const char* getDefaultStatFile() {
	return DEFAULT_STAT_FILE;
}

int getDefaultNiceness() {
	return DEFAULT_NICENESS;
}

/*
** Local Variables:
** c-basic-offset: 3
** tab-width: 3
** End:
** vim600: fdm=marker
** vim: noet ts=3 sw=3
*/
